%% RUN THE MODELS AND SAVE
%==========================================================================
clear all
clc
addpath('C:\Users\321471\Desktop\CODE\_CODES\DSGE_IRF\')
addpath('C:\Users\321471\Desktop\CODE\_CODES\Pruning\')
addpath('C:\Users\321471\Desktop\CODE\_CODES\')

models  = {'BGG'};

% Run the models
for tt=1:length(models)
    eval( ['dynare ' models{tt} ' noclearall'] );
    clearex models personal legends
end

% Save results from all models in the structure OUT
for tt=1:length(models)
    eval( [ 'load ' models{tt} '_results.mat '] );
    OUT.(models{tt}).M_ = M_;
    OUT.(models{tt}).oo_= oo_;
    OUT.(models{tt}).options_ = options_;
end
disp(' ')
disp('-------------------------------------------------------------------')
disp('1. FINISHED -> Steady state computed and results saved')


%% PRUNING
filename_dynarepp = 'C:\dynare\4.3.0\dynare++'; 
order_app = 3;
numsim = 2000;
discard = ceil(.5*numsim);
seednr = 1;
y_select = 'all';
delete_all = 1;

% Run the models
for tt=1:length(models)
    filename_model = [models{tt} 'pp'];
    PRUNE_ErgodicMean
end
disp(' ')
disp('-------------------------------------------------------------------')
disp('2. FINISHED -> Model simulated with pruning')


%% IRF
%==========================================================================
clearex models personal legends

% Number of draws for average response
ndraws = 50;
% Steps for IRFs
IRFsteps = 20;
% Steps for simulation
SIMULsteps = 2000;
% Plot customized IRFs
personal=1;

% Compute IRFs for each model considered (all variables)
for tt=1:length(models)
    clearvars -global 
    load ([(models{tt}) '_results.mat']);
        OUT.(models{tt}).options_ = options_;
        OUT.(models{tt}).oo_ = oo_;
        OUT.(models{tt}).M_ = M_;
        clear options_ oo_ M_
    DSGE_IRF_3
end
if personal==1
    % Plot comparison between models (NOT AUTO: you have to choose the variables)
    variables = {   'C',        'Consumption (%)',               '1';
                    'I',        'Investment (%)',                '1';
                    'Y',        'Total Output (%)',              '1';
                    'N',        'Hours (%)',                     '1';
                    'infl',     'Inflation (annual, %)',         '4';
                    'Rn',       'Policy Rate (annual, %)',       '4';
                    'nw',       'Net worth (%)',                 '1';
                    'rp',       'Risk. Premium (annual, bp)',    '400';
                     };
    DSGE_IRF_Plot_Comparison2
end
clearex models legends

