clear all, close all; clc
clc
addpath('C:\Users\321471\Desktop\CODE\_CODES\DSGE_IRF\')
addpath('C:\Users\321471\Desktop\CODE\_CODES\Pruning\')
addpath('C:\Users\321471\Desktop\CODE\_CODES\')

models  = {'BGG'};

%% DATA MOMENTS
DATA = xlsread('Data.xlsx','Sheet1');
% HP filter levels
logDATA = log(DATA);
[logDATA_T, logDATA_C] = hpfilter(logDATA,1600);
% logDATA_C = bpass(logDATA,6,32);
% EFP enters in levels
logDATA_C(:,end) = DATA(:,end);
% Stats
[aux1, DATAstats_l] = SummStats(logDATA_C);
DATAstats = 100*aux1;
% DATA TABLE
    % Stdev
    TABLE(1,1) = DATAstats(6,1);
    TABLE(2,1) = DATAstats(6,2)/DATAstats(6,1);
    TABLE(3,1) = DATAstats(6,3)/DATAstats(6,1);
    TABLE(4,1) = DATAstats(6,4)/DATAstats(6,1);
    TABLE(5,1) = DATAstats(6,5);
    % Autocorr
    TABLE(6,1) = DATAstats(7,1)./100;
    TABLE(7,1) = DATAstats(7,2)./100;
    TABLE(8,1) = DATAstats(7,3)./100;
    TABLE(9,1) = DATAstats(7,4)./100;
    TABLE(10,1) = DATAstats(7,5)./100;
    % Corr with Y
    TABLE(11,1) = corr(logDATA_C(:,1),logDATA_C(:,2));
    TABLE(12,1) = corr(logDATA_C(:,1),logDATA_C(:,3));
    TABLE(13,1) = corr(logDATA_C(:,1),logDATA_C(:,4));
    aux = CommonSample([logDATA_C(:,1) logDATA_C(:,5)]);
    TABLE(14,1) = corr(aux(:,1),aux(:,2));
   
    
%% MODELS MOMENTS
% Settings
filename_dynarepp = 'C:\dynare\4.3.0\dynare++'; 
order_app = 3;
numsim = 2000;
discard = ceil(.5*numsim);
seednr = 1;
y_select = 'all';
delete_all = 1;
% Run the models
for tt=1:length(models)
    filename_model = [models{tt} 'pp'];
    PRUNE_ErgodicMean
    SIMUL.(models{tt}) = xy_sim;
    disp(models{tt});
end
clearex names SIMUL models TABLE logDATA_C
% Select variables 
select = {'Y';'C';'I';'N';'efp'};
for ii=1:length(select)
    aux(ii,1) = strmatch(select{ii},strtrim(names),'exact');
end
% Loop pver models to compute stats
for tt=1:length(models)
    MODEL = log(SIMUL.(models{tt})(aux,end-168:end))';
    % HP filter levels
    MODEL_T = hpfilter(MODEL,1600);
    MODEL_C = MODEL - MODEL_T;
    % EFP enters in levels
    MODEL_C(:,end) = MODEL(:,end);
    % Stats
    [aux1, ~] = SummStats(MODEL_C);
    MODELstats.(models{tt}) = 100*aux1;
    % MODELS TABLE
        % Stdev
        TABLE(1,tt+1) = MODELstats.(models{tt})(6,1);
        TABLE(2,tt+1) = MODELstats.(models{tt})(6,2)/MODELstats.(models{tt})(6,1);
        TABLE(3,tt+1) = MODELstats.(models{tt})(6,3)/MODELstats.(models{tt})(6,1);
        TABLE(4,tt+1) = MODELstats.(models{tt})(6,4)/MODELstats.(models{tt})(6,1);
        TABLE(5,tt+1) = MODELstats.(models{tt})(6,5);
        % Autocorr
        TABLE(6,tt+1) = MODELstats.(models{tt})(7,1)./100;
        TABLE(7,tt+1) = MODELstats.(models{tt})(7,2)./100;
        TABLE(8,tt+1) = MODELstats.(models{tt})(7,3)./100;
        TABLE(9,tt+1) = MODELstats.(models{tt})(7,4)./100;
        TABLE(10,tt+1) = MODELstats.(models{tt})(7,5)./100;
        % Corr with Y
        TABLE(11,tt+1) = corr(MODEL_C(:,1),MODEL_C(:,2));
        TABLE(12,tt+1) = corr(MODEL_C(:,1),MODEL_C(:,3));
        TABLE(13,tt+1) = corr(MODEL_C(:,1),MODEL_C(:,4));
        TABLE(14,tt+1) = corr(MODEL_C(:,1),MODEL_C(:,5));
        disp(models{tt});
end

OUT = TabPrint(TABLE,[{'Data'} models],{'std(Y)';'std(C)/std(Y)';'std(I)/std(Y)';'std(N)/std(Y)';'std(EFP)';...
                                        'AutoCorr(Y)';'AutoCorr(C)';'AutoCorr(I)';'AutoCorr(N)';'AutoCorr(EFP)';...
                                        'Corr(C,Y)';'Corr(I,Y)';'Corr(N,Y)';'Corr(EFP,Y)'},6);
xlswrite('Results.xls',OUT,'Sheet1');
