% this code computes irf using as initial value a file ergodic_mean.mat
% with names and values. To be used with pruning code

% Order of the solution
order = OUT.(models{tt}).options_.order;

% Number of end variables and number of shocks 
OUT.(models{tt}).nendovar = size(OUT.(models{tt}).M_.endo_names,1);
OUT.(models{tt}).nexovar  = size(OUT.(models{tt}).M_.exo_names,1);


%% Comparison?
% disp(' ')
% disp('Non linear IRFs are different using different starting points.')
% disp('How many IRFs do you want to compare?:')
% comparison = input('? ');
comparison = 1;

%% Choose which type of IRF you want to plot
% disp(' ')
% disp('Choose the alternative initial conditions:')
% disp('1 --> From Steady State')
% disp('2 --> From externally provided initial conditions')
for hh=1:comparison
%     irf_type(hh) = input('? ');
    irf_type(hh) = 2;
end
    
%% Define which exogenous process to shock
% disp('Which shock ?')
% junk(1:OUT.(models{tt}).nexovar,1)={': '};
% disp(' ')
% disp([num2str([1:OUT.(models{tt}).nexovar]') char(junk) OUT.(models{tt}).M_.exo_names])
% whichShock = input('? ');
whichShock = 3;
clear junk


%% Compute IRFs
for hh=1:comparison % loop for comparison
    
    %% Initialize
%     IRFdraws(1:OUT.(models{tt}).nendovar,1:IRFsteps+1,1:ndraws) = NaN;
%     IRF(1:OUT.(models{tt}).nendovar,1:IRFsteps+1,1:comparison) = NaN;

    IRF2draws(1:OUT.(models{tt}).nendovar,1:IRFsteps+1,1:ndraws) = NaN;
    IRF2(1:OUT.(models{tt}).nendovar,1:IRFsteps+1,1:comparison) = NaN;

    IRF1draws(1:OUT.(models{tt}).nendovar,1:IRFsteps+1,1:ndraws) = NaN;
    IRF1(1:OUT.(models{tt}).nendovar,1:IRFsteps+1,1:comparison) = NaN;
    
    % Loop to compute mean response
    kk = 1; 
    while kk <= ndraws
        disp('---------------------------')
        disp(['Draw #: ' num2str(kk)]) % this is the number of draws to compute the average IRF

       
        switch irf_type(hh)
            case 1
                initial = OUT.(models{tt}).oo_.steady_state;
            case 2
                eval( ['load ' models{tt} '_ergodic_mean.mat'] );
                reorder(1:length(names),1) = NaN;
                for mm=1:length(names)
                    for nn=1:OUT.(models{tt}).nendovar
                        aux = strcmp(strtrim(names{mm}),strtrim(OUT.(models{tt}).M_.endo_names(nn,:)));
                        if aux==1
                            reorder(mm,1) = nn;
                        end
                    end
                end
                % reorder
                initial = zeros(OUT.(models{tt}).nendovar,1);
                for nn=1:length(names)
                    if ~isnan(reorder(nn))
                        initial(reorder(nn),1) = ergo_mean(nn);
                        names_reordered(reorder(nn),1) = names(nn);
                    end
                end
        end

        %% Create the shocks and compute IRFs
        % Draw random shock1 and simulate the model to get Y1
        shock1 = zeros(IRFsteps,OUT.(models{tt}).nexovar);
        shock1(:,whichShock) = randn(IRFsteps,1);
%         global M_ options_
%         M_ = OUT.(models{tt}).M_; M_ = OUT.(models{tt}).options_; 
        Y1 = simult_(initial,OUT.(models{tt}).oo_.dr,shock1,order);

        % shock2 is equal to shock1 +1 standard deviation at chosen point. 
        % Then simulate the model to get Y2  
        shock2 = shock1;
        shock2(1,whichShock) = 1 + shock2(1,whichShock);
        Y2 = simult_(initial,OUT.(models{tt}).oo_.dr,shock2,order);

        % If there NaNs in Y1 or Y2 drop the draw
        % Otherwise IRF is difference between Y2 and Y1
        if or( or( sum(sum(isnan(Y1)))>0, sum(sum(Y1>10^4))>0 ), or( sum(sum(isnan(Y2)))>0, sum(sum(Y2>10^10))>0 ))
            disp(['!WARNING! - IRF not stable. Repeat draw #: ' num2str(kk)])
        else
%             IRFdraws(:,:,kk) = log(Y2)-log(Y1); WRONG NOT A PERCENT CHANGE!
            IRF2draws(:,:,kk) = Y2;
            IRF1draws(:,:,kk) = Y1;
            kk = kk+1;
        end
       
        % disp(num2str(sum(sum(isnan(Y)))));
        % disp(num2str(sum(sum(isnan(Y1)))));
        % disp(num2str(sum(sum(isnan(Y2)))));
        
        % Clean
        clear initial Y select
    end

    % Average over the number of draws
%     OUT.(models{tt}).IRF(:,:,hh) = mean(IRFdraws,3);
    OUT.(models{tt}).IRF2(:,:,hh) = mean(IRF2draws,3);
    OUT.(models{tt}).IRF1(:,:,hh) = mean(IRF1draws,3);
    
    disp(' ')
    disp(['============ End of IRF for comparison ' num2str(hh) ' ============']);
    disp(' ')    
end






