%% Preliminaries
set(0,'DefaultTextFontName','Palatino')
set(0,'DefaultAxesFontName','Palatino')
linestyle = {'-';'--';':';'-x';'-s'};
linecolor = {'dark blue';'slightly dark green';'dark grey';'light red ';'very light blue'};
subplots  = {'Random';'Ergodic mean';'Steady state';'Boom';'Bust'};
first_obs = 1; %0 if you want th eIRF to start from 0 (no shock), 1 otherwise
mkdir('IRF')

%% Plot
if ceil(sqrt(OUT.(models{tt}).nendovar))>3
    nplots = 4;
else
    nplots = ceil(sqrt(OUT.(models{tt}).nendovar));
end
    
NumFig = ceil(OUT.(models{tt}).nendovar/nplots^2);

FigSize(32,16)
mm = 1; % mm indexes the figure number
nn = 1; % nn indexes the variable number
while mm<NumFig+1
    for ii=1:nplots^2 % ii indexes the subplot
        if nn>OUT.(models{tt}).nendovar
            break
        end
        subplot(nplots,nplots,ii)
        if first_obs==0
            x = [0:IRFsteps];
            xaxis = zeros(1,IRFsteps+1);
        else
            x = [1:IRFsteps];
            xaxis = zeros(1,IRFsteps);
        end
        for jj=1:comparison % jj indexes the comparison
            aux = OUT.(models{tt}).IRF(nn,:,jj);
            if first_obs==0
                plot(x,100*aux,linestyle{jj},'Color',rgb(linecolor{jj}),'LineWidth',2);
            else
                plot(x,100*aux(2:end),linestyle{jj},'Color',rgb(linecolor{jj}),'LineWidth',2);
            end
            hold on
            upp(jj) = max(100*aux);
            low(jj) = min(100*aux);
        end
        plot(x,xaxis,'-k','LineWidth',.5)
        if first_obs==0
            xlim([0 IRFsteps])
        else
            xlim([1 IRFsteps])
        end
        if or(min(low),max(upp)) ~= 0
            ylim( [min(low) max(upp)])
        end
        title(OUT.(models{tt}).M_.endo_names(nn,:),'FontWeight','Bold')
        nn = nn + 1;
    end
    figure_name = ['IRF\' OUT.(models{tt}).M_.fname '_' strtrim(OUT.(models{tt}).M_.exo_names(whichShock,:)) '_' num2str(mm)];
    LegendSubplot(subplots(irf_type),.2)
    set(gcf, 'Color', 'w');
    export_fig(figure_name,'-pdf')
    SupTitle(['Model ' models{tt} ' - Impulse Response to ' strtrim(OUT.(models{tt}).M_.exo_names(whichShock,:))])
    export_fig(figure_name,'-png')
%     print(figure_name,'-dpdf'); print(figure_name,'-dpng')
    clf('reset');
    mm=mm+1;
end

close all