function out = printSS(M_,oo_)
% =======================================================================
% Print to screen the steady state of the model
% =======================================================================
% function out = printSS(M_,oo_)
% -----------------------------------------------------------------------
% INPUTS 
%	M_  : Dynare structure containing variables' names
%   oo_ : Dynare structure containing variables' steady state
%
% OUPUT
%   out : cell matrix wih names and steady state values
% =========================================================================
% Ambrogio Cesa Bianchi, August 2012
%-------------------------------------------------------------------------

nvar = length(oo_.steady_state);

for ii=1:nvar
    out(ii,1) = {strtrim(M_.endo_names(ii,:))};
    out(ii,2) = {num2str(oo_.steady_state(ii,1))};
end